#ifndef PARTICLES_H
#define PARTICLES_H

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <math.h>
#include <XRS/Array.h>
#include "Cell.h"

/****************************************************
	      γ
****************************************************/

class Particle;           
Lattice<Particle>  cell;   // γҸѤγʻ

class Particle
{  
 private:
   double fx0,fy0,vx0,vy0;   // ư򤯤ΰѿ
   int    i,j,n;             // ʻֹ¸뤿ѿ

 public:
   double x,y;       // ɸ
   double fx,fy;     //  (fx,fy)
   double vx,vy;     // ®
   double dx,dy;     // ɸ (x,y)1֥ƥåפˤĤƤʬ    

   Particle():fx0(0),fy0(0),vx0(0),vy0(0),x(0),y(0),
              fx(0),fy(0),vx(0),vy(0),dx(0),dy(0){}; 

   void init(double,double);     // ֡Ⱦ¤ 
   void move(void);              // 1ƥåפǤγҤαư 
   inline void set(int ii, int jj,int nn){ i=ii; j=jj; n=nn;}  
   inline int Li(){ return i; }
   inline int Lj(){ return j; }
   inline int Ln(){ return n; }
};


//  1ƥåפǤγҤαư 
void Particle::move(void)                    
{
     double dt2=dt*0.5, dt3=dt*1.5;

     // ¿
     vx+=fx*dt3-fx0*dt2;   dx=(vx+vx0)*dt2;   vx0=vx;   fx0=fx;  
     vy+=fy*dt3-fy0*dt2;   dy=(vy+vy0)*dt2;   vy0=vy;   fy0=fy;   
     x=x+dx; y=y+dy;
}

#endif PARTICLES_H
